import { NativeModules, Platform } from 'react-native';

const LINKING_ERROR =
  `The package 'zeo-collect' doesn't seem to be linked. Make sure: \n\n` +
  Platform.select({ ios: "- You have run 'pod install'\n", default: '' }) +
  '- You rebuilt the app after installing the package\n' +
  '- You are not using Expo Go\n';

const ZeoCollect = NativeModules.ZeoCollect
  ? NativeModules.ZeoCollect
  : new Proxy(
      {},
      {
        get() {
          throw new Error(LINKING_ERROR);
        },
      }
    );


    export function setEventNameProperties(eventName: string) {
       ZeoCollect.setEventNameProperties(eventName);
    }
    
    export function setEventProperties(eventName: string, eventProp: {[key: string]: any}) {
       ZeoCollect.setEventProperties(eventName, eventProp);
    }
    
    export function setInstantEventNameProperties(eventName: string) {
       ZeoCollect.setInstantEventNameProperties(eventName);
    }
    
    export function setInstantEventProperties(eventName: string, eventProp: {[key: string]: any}) {
       ZeoCollect.setInstantEventProperties(eventName, eventProp);
    }
    
    export function setUserIdentities(userProp: {[key: string]: any}) {
       ZeoCollect.setUserIdentities(userProp);
    }
    
    export function setUserProperties(userProp: {[key: string]: any}) {
       ZeoCollect.setUserProperties(userProp);
    }
    
    export function setPageProperties(userProp: {[key: string]: any}) {
       ZeoCollect.setPageProperties(userProp);
    }
    
    export function unsetUserIdentities() {
       ZeoCollect.unsetUserIdentities();
    }
    
    export function pauseCollection() {
       ZeoCollect.pauseCollection();
    }    
    
    export function resumeCollection() {
       ZeoCollect.resumeCollection();
    }
    
    export function setConsent(consent: {[key: string]: any}) {
       ZeoCollect.setConsent(consent);
    }
    
    export function listenToAskForConsent(cb: any) {
       ZeoCollect.listenToAskForConsent(cb);
    }
    
    export function getZI(cb: any) {
       ZeoCollect.getZI(cb);
    }
    
    export function resetZI() {
       ZeoCollect.resetZI();
    }

    export function setZI(zi: string) {
       ZeoCollect.setZI(zi);
    }

    export function setATTStatusAndAdvertisingId(status: string, advertisingId: string) {
       ZeoCollect.setATTStatusAndAdvertisingId(status, advertisingId);
    }

    export function setAdvertisingIdByATTStatus(status: string) {
       ZeoCollect.setAdvertisingIdByATTStatus(status);
    }

    export function setAndroidAdID(adID: string) {
      ZeoCollect.setAndroidAdID(adID);
   }

    export function initialiseZeoCollect(options: {[key: string]: any}) {
      ZeoCollect.initalizeBySettingOptions(options);
    }
    